<%-- 
    Mi Tienda Pagadito 3.0 (JAVA)
    Es un ejemplo de plataforma de e-commerce, que realiza venta de productos
    electrnicos, y efecta los cobros utilizando Pagadito, a travs del WSPG.
 
    cobro.jsp
 
    Este script procesa la transaccin a peticin del script index.jsp. Se
    comunica con el WSPG para conectarse y registrar la transaccin.
 
    LICENCIA: ste cdigo fuente es de uso libre. Su comercializacin no est
    permitida. Toda publicacin o mencin del mismo, debe ser referenciada a
    su autor original Pagadito.com.
 
    @author      Pagadito.com <soporte@pagadito.com>
    @copyright   Copyright (c) 2012, Pagadito.com
    @version     1.0
    @link        https://dev.pagadito.com/index.php?mod=docs&hac=wspg
--%>

<%@page import="java.net.URLDecoder"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.AbstractList"%>
<%@page import="java.util.List"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Map"%>
<%@page import="java.io.StringReader"%>
<%@page import="org.xml.sax.InputSource"%>
<%@page import="javax.xml.parsers.*"%>
<%@page import="org.w3c.dom.*"%>
<%--
    Se incluye el script config.js que contiene las constantes de conexin.
--%>
<%@include file="config.jsp"%>
<%!
    /**
     * Transforma una cadena de texto con contenido XML a una estructura HashMap
     * @param String respuesta Cadena con los datos XML.
     * @return HashMap
     */
    public HashMap decode_xml_response(String respuesta){
        HashMap obj_response = new HashMap();
        try{
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            InputSource is = new InputSource();
            is.setCharacterStream(new StringReader(respuesta));
            Document doc = db.parse(is);
            NodeList nodes = doc.getElementsByTagName("response");
            Element element = (Element) nodes.item(0);
            
            //code
            String code = get_xml_value(element, "code");
            obj_response.put("code", code);
            //message
            String message = get_xml_value(element, "message");
            obj_response.put("message", message);
            //value
            String value = get_xml_value(element, "value");
            obj_response.put("value", value);
            //datetime
            String datetime = get_xml_value(element, "datetime");            
            obj_response.put("datetime", datetime);
            
            return obj_response;
        }
        catch(Exception err){
            err.printStackTrace();
            return null;
        }
    }
    
    /**
     * Devuelve el valor del tem solicitado.
     * @param Element element Objeto con datos provenientes de un XML.
     * @param String item Nombre del tem solicitado.
     * @return String
     */
    public String get_xml_value(Element element, String item){
        NodeList name = element.getElementsByTagName(item);
        Element line = (Element) name.item(0);
        Node child = line.getFirstChild();
        if (child instanceof CharacterData) {
            CharacterData cd = (CharacterData) child;
            String value = cd.getData();
            return value;
        }
        else{
            return "";
        }
    }
%>
<%
    if(request.getParameter("cantidad1") != "" && request.getParameter("cantidad2") != "" && request.getParameter("cantidad3") != ""){
        Integer cantidad1 = 0;
        Integer cantidad2 = 0;
        Integer cantidad3 = 0;
        try{
            cantidad1 = Integer.parseInt(request.getParameter("cantidad1"));
            cantidad2 = Integer.parseInt(request.getParameter("cantidad2"));
            cantidad3 = Integer.parseInt(request.getParameter("cantidad3"));
        }
        catch(Exception err){
            out.println(""
                + "<script>"
                + "     alert('No ha llenado los campos adecuadamente.');"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        /*
         * Lo primero ser consumir la operacin 'connect', a la cual le
         * pasaremos el UID y WSK para solicitarle un token de conexin al WSPG.
         * Alternativamente le enviamos el formato en el que queremos que nos
         * responda el WSPG, en este ejemplo solicitamos el formato XML.
         */
        cliente_pagadito.Wspg cliente = new cliente_pagadito.Wspg_Impl();
        cliente_pagadito.WspgPortType clientePort = cliente.getWspgPort();
        String respuesta = clientePort.connect(UID, WSK, "xml");
        //decodificando respuesta
        HashMap obj_respuesta = decode_xml_response(respuesta);
        if(obj_respuesta.get("code").equals("PG1001")){
            /*
             * En caso de haber recibido un token exitosamente,
             * procedemos a definir los detalles de la venta.
             */
            List<HashMap> details = new ArrayList<HashMap>();
            HashMap detail = new HashMap();
            if(cantidad1 > 0){
                detail.put("quantity", request.getParameter("cantidad1"));
                detail.put("description", request.getParameter("descripcion1"));
                detail.put("price", request.getParameter("precio1"));
                detail.put("url_product", request.getParameter("url1"));
                details.add(detail);
            }
            if(cantidad2 > 0){
                detail = new HashMap();
                detail.put("quantity", request.getParameter("cantidad2"));
                detail.put("description", request.getParameter("descripcion2"));
                detail.put("price", request.getParameter("precio2"));
                detail.put("url_product", request.getParameter("url2"));
                details.add(detail);
            }
            if(cantidad3 > 0){
                detail = new HashMap();
                detail.put("quantity", request.getParameter("cantidad3"));
                detail.put("description", request.getParameter("descripcion3"));
                detail.put("price", request.getParameter("precio3"));
                detail.put("url_product", request.getParameter("url3"));
                details.add(detail);
            }
            /*
             * Armamos nuestros detalles en formato xml
             */
            String xml_details = "<details>\n";
            for(int i = 0; i < details.size(); i++){
                detail = details.get(i);
                xml_details += "<detail>\n";
                xml_details += "<quantity>" + detail.get("quantity") + "</quantity>\n";
                xml_details += "<description>" + detail.get("description") + "</description>\n";
                xml_details += "<price>" + detail.get("price") + "</price>\n";
                xml_details += "<url_product>" + detail.get("url_product") + "</url_product>\n";
                xml_details += "</detail>\n";
            }
            xml_details += "</details>";
            /*
             * Calculamos el monto de la transaccn
             */
            Double amount = 0.0;
            amount += Double.parseDouble(request.getParameter("cantidad1")) * Double.parseDouble(request.getParameter("precio1"));
            amount += Double.parseDouble(request.getParameter("cantidad2")) * Double.parseDouble(request.getParameter("precio2"));
            amount += Double.parseDouble(request.getParameter("cantidad3")) * Double.parseDouble(request.getParameter("precio3"));
            /*
             * A continuacin, procedemos a consumir la operacin
             * exec_trans, para solicitar al WSPG que registre nuestra
             * transaccin. Para ello le enviamos token, ern, amount y
             * details. Alternativamente, le enviamos el formato en el
             * que queremos que nos responda el WSPG, en este ejemplo
             * solicitamos el formato XML.
             *
             * A manera de ejemplo el ern es generado como un nmero
             * aleatorio. Lo ideal es que sea una referencia almacenada
             * por el Pagadito Comercio.
             */
            respuesta = clientePort.exec_trans(obj_respuesta.get("value").toString(), request.getParameter("ern"), amount.toString(), xml_details, "xml");
            //decodificando respuesta
            obj_respuesta = decode_xml_response(respuesta);
            out.println(obj_respuesta.get("message"));
            if(obj_respuesta.get("code").equals("PG1002")){
                /*
                 * En caso de haberse registrado la transaccin
                 * exitosamente, redireccionamos al usuario a la
                 * URL devuelta por el WSPG.
                 */
                response.sendRedirect(URLDecoder.decode(obj_respuesta.get("value").toString()));
            }
            else if(obj_respuesta.get("code").equals("PG2001")){
                /*
                 * Tratamiento para datos incompletos.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3002")){
                /*
                 * Tratamiento para error.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3003")){
                /*
                 * Tratamiento para transaccin no registrada.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3004")){
                /*
                 * Tratamiento para monto desigual
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3006")){
                /*
                 * Tratamiento para monto excedido.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3007")){
                /*
                 * Tratamiento para acceso denegado.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else{
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
        }
        else if(obj_respuesta.get("code").equals("PG2001")){
            /*
             * Tratamiento para datos incompletos.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else if(obj_respuesta.get("code").equals("PG3001")){
            /*
             * Tratamiento para conexin dengada.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else if(obj_respuesta.get("code").equals("PG3002")){
            /*
             * Tratamiento para error.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else if(obj_respuesta.get("code").equals("PG3005")){
            /*
             * Tratamiento para conexin deshabilitada.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else{
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
    }
    else{
        out.println(""
                + "<script>"
                + "     alert('No ha llenado los campos adecuadamente.');"
                + "     location.href = 'index.jsp';"
                + "</script>");
    }
%>