<%-- 
    Mi Tienda Pagadito 3.0 (JAVA)
    Es un ejemplo de plataforma de e-commerce, que realiza venta de productos
    electrónicos, y efectúa los cobros utilizando Pagadito, a través del WSPG.
 
    payback.jsp
 
    Este script recibe la redirección desde Pagadito una vez la transacción ha
    sido finalizada. Se conecta al WSPG y consulta el estado de la transacción.
 
    LICENCIA: Éste código fuente es de uso libre. Su comercialización no está
    permitida. Toda publicación o mención del mismo, debe ser referenciada a
    su autor original Pagadito.com.
 
    @author      Pagadito.com <soporte@pagadito.com>
    @copyright   Copyright (c) 2012, Pagadito.com
    @version     1.0
    @link        https://dev.pagadito.com/index.php?mod=docs&hac=wspg
--%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Map"%>
<%@page import="java.io.StringReader"%>
<%@page import="org.xml.sax.InputSource"%>
<%@page import="javax.xml.parsers.*"%>
<%@page import="org.w3c.dom.*"%>
<%@include file="config.jsp"%>
<%!
    /**
     * Transforma una cadena de texto con contenido XML a una estructura HashMap
     * @param String respuesta Cadena con los datos XML.
     * @return HashMap
     */
    public HashMap decode_xml_response(String respuesta){
        HashMap obj_response = new HashMap();
        try{
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            InputSource is = new InputSource();
            is.setCharacterStream(new StringReader(respuesta));
            Document doc = db.parse(is);
            NodeList nodes = doc.getElementsByTagName("response");
            Element element = (Element) nodes.item(0);
            
            //code
            String code = get_xml_value(element, "code");
            obj_response.put("code", code);
            //message
            String message = get_xml_value(element, "message");
            obj_response.put("message", message);
            //value
            Object value = get_xml_value(element, "value");
            obj_response.put("value", value);
            //datetime
            String datetime = get_xml_value(element, "datetime");            
            obj_response.put("datetime", datetime);
            
            return obj_response;
        }
        catch(Exception err){
            err.printStackTrace();
            return null;
        }
    }
    
    /**
     * Transforma una cadena de texto con contenido XML a una estructura HashMap
     * incluyendo sus elementos hijos. Es por esta última característica que se
     * redefine la función, para ser utilizada junto con la llamada a la operación
     * del WSPG exec_trans.
     * @param String respuesta Cadena con los datos XML.
     * @return HashMap
     */
    public HashMap decode_xml_response_extended(String respuesta){
        HashMap obj_response = new HashMap();
        try{
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            InputSource is = new InputSource();
            is.setCharacterStream(new StringReader(respuesta));
            Document doc = db.parse(is);
            NodeList nodes = doc.getElementsByTagName("response");
            Element element = (Element) nodes.item(0);
            
            //code
            String code = get_xml_value(element, "code");
            obj_response.put("code", code);
            //message
            String message = get_xml_value(element, "message");
            obj_response.put("message", message);
            //value
            Element value = get_xml_element(element, "value");
            obj_response.put("value", value);
            //status
            String status = get_xml_value(value, "status");
            obj_response.put("status", status);
            //status
            String reference = get_xml_value(value, "reference");
            obj_response.put("reference", reference);
            //status
            String date_trans = get_xml_value(value, "date_trans");
            obj_response.put("date_trans", date_trans);
            //datetime
            String datetime = get_xml_value(element, "datetime");            
            obj_response.put("datetime", datetime);
            
            return obj_response;
        }
        catch(Exception err){
            err.printStackTrace();
            return null;
        }
    }
    
    /**
     * Devuelve el valor del ítem solicitado.
     * @param Element element Objeto con datos provenientes de un XML.
     * @param String item Nombre del ítem solicitado.
     * @return String
     */
    public String get_xml_value(Element element, String item){
        NodeList name = element.getElementsByTagName(item);
        Element line = (Element) name.item(0);
        Node child = line.getFirstChild();
        if (child instanceof CharacterData) {
            CharacterData cd = (CharacterData) child;
            String value = cd.getData();
            return value;
        }
        else{
            return "";
        }
    }
    
    /**
     * Devuelve el objeto del ítem solicitado.
     * @param Element element Objeto con datos provenientes de un XML.
     * @param String item Nombre del ítem solicitado.
     * @return Element
     */
    public Element get_xml_element(Element element, String item){
        NodeList name = element.getElementsByTagName(item);
        Element line = (Element) name.item(0);
        return line;
    }
%>
<%
    String msg = "";
    if(request.getParameter("token") != ""){
        /*
         * Lo primero será consumir la operación 'connect', a la cual le
         * pasaremos el UID y WSK para solicitarle un token de conexión al WSPG.
         * Alternativamente le enviamos el formato en el que queremos que nos
         * responda el WSPG, en este ejemplo solicitamos el formato XML.
         */
        cliente_pagadito.Wspg cliente = new cliente_pagadito.Wspg_Impl();
        cliente_pagadito.WspgPortType clientePort = cliente.getWspgPort();
        String respuesta = clientePort.connect(UID, WSK, "xml");
        //decodificando respuesta
        HashMap obj_respuesta = decode_xml_response(respuesta);
        if(obj_respuesta.get("code").equals("PG1001")){
            /*
             * En caso de haber recibido un token exitosamente,
             * procedemos a definir los detalles de la venta.
             */
            respuesta = clientePort.get_status(obj_respuesta.get("value").toString(), request.getParameter("token"), "xml");
            obj_respuesta = decode_xml_response_extended(respuesta);
            if(obj_respuesta.get("code").equals("PG1003")){
                if(obj_respuesta.get("status").equals("COMPLETED")){
                    /*
                     * Tratamiento para una transacción exitosa.
                     */
                    msg = "Gracias por comprar en Mi Tienda Pagadito.<br /><br />Referencia: " + obj_respuesta.get("reference").toString() + "<br />Fecha: " + obj_respuesta.get("date_trans").toString();
                }
                else if(obj_respuesta.get("status").equals("REGISTERED")){
                    /*
                     * Tratamiento para una transacción aún en
                     * proceso.
                     */
                    msg = "La transacci&oacute;n a&uacute;n est&aacute; en proceso.";
                }
                else if(obj_respuesta.get("status").equals("FAILED")){
                    /*
                     * Tratamiento para una transacción fallida.
                     */
                    msg = "Lo sentimos, la compra no pudo realizarse.";
                }
                else{
                    msg = "Lo sentimos, la compra no pudo realizarse.";
                }
            }
            else if(obj_respuesta.get("code").equals("PG2001")){
                /*
                 * Tratamiento para datos incompletos.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3002")){
                /*
                 * Tratamiento para error.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3003")){
                /*
                 * Tratamiento para transacción no registrada.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(obj_respuesta.get("code").equals("PG3007")){
                /*
                 * Tratamiento para acceso denegado.
                 */
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else{
                out.println(""
                    + "<script>"
                    + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
        }
        else if(obj_respuesta.get("code").equals("PG2001")){
            /*
             * Tratamiento para datos incompletos.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else if(obj_respuesta.get("code").equals("PG3001")){
            /*
             * Tratamiento para conexión dengada.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else if(obj_respuesta.get("code").equals("PG3002")){
            /*
             * Tratamiento para error.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else if(obj_respuesta.get("code").equals("PG3005")){
            /*
             * Tratamiento para conexión deshabilitada.
             */
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        else{
            out.println(""
                + "<script>"
                + "     alert(\"" + obj_respuesta.get("code") + ": " + obj_respuesta.get("message") + "\");"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
    }
    else{
        out.println(""
            + "<script>"
            + "     alert('No se han recibido los datos correctamente.');"
            + "     location.href = 'index.jsp';"
            + "</script>");
    }
%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<html>
    <head>
        <title>Guillenos</title>
        <link type="text/css" rel="stylesheet" href="css/default.css" media="screen" />
    </head>
    <body>
        <div id="topBar">
            <div id="center">
                <div id="site"></div>
                <div class="clear"></div>
            </div>
        </div>
        <div id="wrapper">
            <div id="header">
                <img id="logo" src="imagenes/logo.png" title="Guillenos" alt="Guillenos" />
            </div>
            <div id="content">
                <br />
                <%=msg%>
                <br />
                <a href="index.jsp">Volver a comprar</a>
            </div>
        </div>
    </body>
</html>